/* Copyright (c) 2000-2003 ActiveState Corp.
   See the file LICENSE.txt for licensing information. */

/* Ask the user for two file to compare. */

var log = getLoggingMgr().getLogger("dialogs.compare");
//log.setLevel(LOG_DEBUG);

//---- interface routines for XUL

function OnLoad()
{
    try {
        trace_onload();
        var dialog = document.getElementById("dialog");
        var okButton = dialog.getButton("accept");
        okButton.setAttribute("accesskey", "c");
        okButton.setAttribute("label", "Compare Files");
        okButton.setAttribute("disabled", "true");
        var first = document.getElementById('first')
        var second = document.getElementById('second');
        window.title = "Compare Two Files";

        var dummy = new MRUAutoCompleteSession(first);
        dummy = new MRUAutoCompleteSession(second);

        if (opener.gViewMgr &&
            opener.gViewMgr.currentView &&
            opener.gViewMgr.currentView.getAttribute('type') == 'editor' &&
            ! opener.gViewMgr.currentView.document.isUntitled) {
            first.value = opener.gViewMgr.currentView.document.displayPath;
            second.focus();
        } else {
            // Prefill the two entries with the last used ones.
            var prefName = first.getAttribute("komodo-preference-set");
            first.value = MRU_get(prefName);
            prefName = second.getAttribute("komodo-preference-set");
            second.value = MRU_get(prefName);
            first.focus();
        }
        updateOK();
    
        window.sizeToContent();
        if (opener.innerHeight == 0) { // indicator that opener hasn't loaded yet
            dialog.centerWindowOnScreen();
        } else {
            dialog.moveToAlertPosition(); // requires a loaded opener
        }
    } catch (e) {
        log.exception(e);
    }
}

function choose(which)
{
    file = filepicker_openFile(null, null, "Please select the " + which + " file:");
    if (!file) return;
    document.getElementById(which).value = file;
    updateOK();
}

function updateOK()
{
    var ok = document.getElementById('first').value && document.getElementById('second').value;
    var dialog = document.getElementById("dialog");
    var okButton = dialog.getButton("accept");
    if (ok) {
        if (okButton.hasAttribute('disabled')) {
            okButton.removeAttribute('disabled')
        }
    } else {
        okButton.setAttribute('disabled', 'true');
    }
}

function OK()
{
    try {
        var os = Components.classes["@activestate.com/koOs;1"].getService();
        var first = document.getElementById('first')
        var second = document.getElementById('second')
        if (!os.path.exists(first.value)) {
            alert("There is no file at '" + first.value + "'.  Please enter another path.");
            first.focus();
            return false
        }
        if (!os.path.exists(second.value)) {
            alert("There is no file at '" + second.value + "'.  Please enter another path.");
            second.focus();
            return false
        }
        MRU_updateFromWidget(first);
        MRU_updateFromWidget(second);
        window.setCursor('wait');
        opener.peFile_ShowDiffs(first.value, second.value)
        window.setCursor('auto');
    } catch (e) {
        log.exception(e);
    }
    return true;
}

function Cancel()
{
    return true;
}

