/* Copyright (c) 2000-2003 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */

var peTemplateLog = getLoggingMgr().getLogger("peTemplate");

// start the extension
registeredExtensions[registeredExtensions.length] = new peTemplate();

function peTemplate() {
    this.name = 'peTemplate';
}

// The following two lines ensure proper inheritance (see Flanagan, p. 144).
peTemplate.prototype.constructor = peTemplate;

peTemplate.prototype.init = function() {
}

peTemplate.prototype.registerCommands = function() {
    extensionManager.registerCommand('cmd_openTemplate', this);
}

peTemplate.prototype.registerEventHandlers = function() {
    extensionManager.addEventHandler(Components.interfaces.koIPart_template,'ondblclick',this);
    extensionManager.addEventHandler(Components.interfaces.koIPart_template,'onUpdatePart',this);
}

peTemplate.prototype.registerMenus = function() {
    extensionManager.createMenuItem(Components.interfaces.koIPart_template,
                                    'Open Template','cmd_openTemplate');
}

peTemplate.prototype.supportsCommand = function(command, part) {
    var view = gFocusedProjectView;
    if (!view) return false;
    switch (command) {
    case 'cmd_openTemplate':
        return true;
    default:
        break;
    }
    return false;
}

peTemplate.prototype.isCommandEnabled = peTemplate.prototype.supportsCommand

peTemplate.prototype.ondblclick = function(part,event) {
    this.openTemplate(part)
}

peTemplate.prototype.doCommand = function(command) {
    switch (command) {
    case 'cmd_openTemplate':
        var items = gFocusedProjectView.getSelectedItems();
        for (var i = 0; i < items.length; i++) {
            if (items[i].type == 'template') this.openTemplate(items[i]);
        }        
        break;
    default:
        break;
    }    
}

peTemplate.prototype.openTemplate = function(item)
{
    var uri = item.part.value;
    gViewMgr.doFileNewFromTemplate(uri);
}

function peTemplate_addTemplate(item)
{
    var index = -1;
    if (typeof(item)=='undefined' || !item)
        item = gFocusedProjectView.getSelectedItem();
    if (item) index = gFocusedProjectView.getIndexByPart(item);    

    var filename = filepicker_openFile();
    var url = uriparse_localPathToURI(filename);
    var templateName = uriparse_baseName(filename);
    var part = Components.classes['@activestate.com/koPart?type=template;1'].
                createInstance(Components.interfaces.koIPart_template);

    part.setStringAttribute('name', templateName);
    part.value = url;

    gFocusedProjectView.manager.addItem(part,index);
}

peTemplate.prototype.onUpdatePart = function(part,event)
{
    if (part.type == 'template') {
        part.renameable = true;
        part.iconstyle['template'] = 1;
    }
}


peTemplate.prototype.editProperties = function(item) {
    var obj = new Object();
    obj.item = item;
    obj.task = 'edit';
    obj.imgsrc = 'chrome://jaguar/skin/images/newTemplate.png';
    obj.type = 'template';
    obj.valueToTextConverter = uriparse_displayPath;
    obj.textToValueConverter = uriparse_localPathToURI;
    obj.prettytype = 'Template';
    openWindowMultipleInstance(
        "chrome://jaguar/content/project/simplePartProperties.xul", 
        "komodo_TemplateProperties",
        "chrome,close=yes,dependent=yes,resizable=yes", obj);
}


// Add the given template to the toolbox.
//
//  "templateURI" is the URI to the template
//
function AddTemplateToToolbox(templateURI) {
    var part = Components.classes['@activestate.com/koPart?type=template;1']
                         .createInstance(Components.interfaces.koIPart_template);
    part.type = 'template';
    var name = uriparse_baseName(templateURI);
    var languageRegistry = Components.classes["@activestate.com/koLanguageRegistryService;1"].getService();
    var language = languageRegistry.suggestLanguageForFile(name);
    part.setStringAttribute('name', name);
    part.value = templateURI;

    toolboxMgr.addItem(part);
}


