/* Copyright (c) 2000-2001 ActiveState SRL. 
   See the file LICENSE.txt for licensing information. */

/* Web Services Setup Wizard - panel */

//---- globals

var _gPanelName = "wsSetup_Warning";


//---- interface for wsSetup_Warning.xul

function OnLoad()
{
    // Give a nice header name for this pane.
    var title = "";
    var desc = "";
    var status = "";
    switch (parent.wd_completionState) {
        case "cancelled":
            title = "Setup Interrupted";
            desc = "Web Services setup was interrupted.";
            status = "The Web Services Setup Wizard was interrupted.";
            break;
        case "error":
            title = "Setup Failed";
            desc = "Web Services setup failed.";
            status = "There was an error installing Web Services "
                     + "support.";
            break;
        case "success":
            title = "Setup Completed";
            desc = "Web Services completed successfully.";
            status = "The Web Services Setup Wizard completed "
                     + "successfully.";
            break;
        default:
            throw("Unknown WS Setup completion state: '"
                  + parent.wd_completionState + "'\n");
            break;
    }
    var headerWidget = parent.document.getElementById("header");
    headerWidget.setAttribute("title", title);
    headerWidget.setAttribute("description", desc);
    
    // <description id="status-msg">
    var statusMsg = document.getElementById("status-msg");
    statusMsg.appendChild(document.createTextNode(status));

    // <textbox id="setup-log" multiline="true" readonly="true"/>
    var setupLogBox = document.getElementById("setup-log-box");
    if (parent.wd_completionState == "cancelled") {
        setupLogBox.setAttribute('collapsed','true');
    } else {
        dump('setting log: '+parent.wd_setupLog+'\n');
        setupLogBox.removeAttribute('collapsed');
        if (parent.wd_setupLog) {
            document.getElementById("setup-log").value = parent.wd_setupLog;
        }
    }

    // <description id="no-changes-made-msg">
    var text = "";
    if (parent.wd_completionState == "cancelled") {
        var noChangesMsg = document.getElementById("no-changes-made-msg");
        noChangesMsg.removeAttribute('collapsed');
        text = "Your " + parent.wd_language + " installation has "
               + "not been modified.";
        noChangesMsg.appendChild(document.createTextNode(text));
    } else {
        document.getElementById("no-changes-made-msg").setAttribute('collapsed','true');
    }
    
    // <description id="things-may-not-work-msg">
    if (parent.wd_completionState == "success") {
        document.getElementById("things-may-not-work-msg").setAttribute('collapsed','true');
    } else {
        var mayNotWorkMsg = document.getElementById("things-may-not-work-msg");
        mayNotWorkMsg.removeAttribute('collapsed');
        text = "Some of Komodo's Web Services features might not "
               + "work for " + parent.wd_language
               + " until Web Services support is installed.";
        mayNotWorkMsg.appendChild(document.createTextNode(text));
    }
    
    // <description id="extra-manual-steps-msg"/>
    var manualStepsMsg = document.getElementById("extra-manual-steps-msg");
    if (parent.wd_completionState == "success") {
        var msg = parent.wsSetupSvcs[parent.wd_language].
                  DescribeManualPostSetupSteps();
        if (msg) {
            manualStepsMsg.removeAttribute('collapsed');
            manualStepsMsg.appendChild(document.createTextNode(msg));
        } else {
            manualStepsMsg.setAttribute('collapsed','true');
        }
    } else {
        manualStepsMsg.setAttribute('collapsed','true');
    }
    
    // Disable the cancel button.
    var cancelButton = parent.document.getElementById("wiz-cancel-button");
    cancelButton.disabled = true;

    parent.wizardManager.onPageLoad(_gPanelName);
}

