CommonStates = [
    'default', 'comments', 'numbers', 'strings', 'keywords',
    'classes', 'functions', 'operators', 'identifiers',
    'stringeol', 'preprocessor', 'bracebad', 'bracehighlight',
    'control characters', 'linenumbers', 'indent guides'
]

# We could move this to the languages
StateMap = {
    'Rx': {
        'default': (0,),
        'breakpoints': (1,),
        'children': (2,),
        'parents': (3,),
    },
    'Python': {
        'default': ('SCE_P_DEFAULT',),
        'comments' : ('SCE_P_COMMENTLINE',
                      'SCE_P_COMMENTBLOCK'),
        'numbers': ('SCE_P_NUMBER',),
        'strings': ('SCE_P_STRING',
                    'SCE_P_CHARACTER', 
                    'SCE_P_TRIPLE',
                    'SCE_P_TRIPLEDOUBLE'),
        'keywords': ('SCE_P_WORD',),
        'classes': ('SCE_P_CLASSNAME',),
        'functions': ('SCE_P_DEFNAME',),
        'operators': ('SCE_P_OPERATOR',),
        'identifiers': ('SCE_P_IDENTIFIER',),
        'stringeol' : ('SCE_P_STRINGEOL',),
        },
    'C++': {
        'default': ('SCE_C_DEFAULT',),
        'comments': ('SCE_C_COMMENT',
                     'SCE_C_COMMENTLINE',
                     'SCE_C_COMMENTLINEDOC',
                     'SCE_C_COMMENTDOC',
                     ),
        'numbers': ('SCE_C_NUMBER',),
        'strings': ('SCE_C_STRING',
                    'SCE_C_CHARACTER',
                    ),
        'keywords': ('SCE_C_WORD',),
        'keywords2': ('SCE_C_WORD2',),
        'operators': ('SCE_C_OPERATOR',),
        'identifiers': ('SCE_C_IDENTIFIER',),
        'stringeol': ('SCE_C_STRINGEOL',),
        'preprocessor': ('SCE_C_PREPROCESSOR',),
        # these are specific to this lexer
        'UUIDs': ('SCE_C_UUID',),
        'verbatim': ('SCE_C_VERBATIM',),
        'regex': ('SCE_C_REGEX',),
        'commentdockeyword': ('SCE_C_COMMENTDOCKEYWORD',),
        'commentdockeyworderror': ('SCE_C_COMMENTDOCKEYWORDERROR',),
        'globalclass': ('SCE_C_GLOBALCLASS',),
        'stringeol' : ('SCE_P_STRINGEOL',),
    },
    'HTML': {
        'default': ('SCE_H_DEFAULT',
                    'SCE_H_SGML_DEFAULT',
                    'SCE_HJ_DEFAULT',
                    'SCE_HJA_DEFAULT',
                    'SCE_HP_DEFAULT',
                    'SCE_HB_DEFAULT',
                    'SCE_HBA_DEFAULT',
                    'SCE_HPA_DEFAULT',
                    ),
        'identifiers': ('SCE_HB_IDENTIFIER',
                        'SCE_HBA_IDENTIFIER',
                        'SCE_HP_IDENTIFIER',
                        'SCE_HPA_IDENTIFIER',
                        ),
        'numbers': ('SCE_H_NUMBER',
                    'SCE_HJ_NUMBER',
                    'SCE_HJA_NUMBER',
                    'SCE_HBA_NUMBER',
                    'SCE_HB_NUMBER',
                    'SCE_HP_NUMBER',
                    'SCE_HPA_NUMBER',
                    'SCE_HPHP_NUMBER',
                    ),
        'strings': ('SCE_H_DOUBLESTRING',
                    'SCE_H_SINGLESTRING',
                    'SCE_H_SGML_DOUBLESTRING',
                    'SCE_H_SGML_SIMPLESTRING',
                    'SCE_HJ_DOUBLESTRING',
                    'SCE_HJ_SINGLESTRING',
                    'SCE_HJA_DOUBLESTRING',
                    'SCE_HJA_SINGLESTRING',
                    'SCE_HB_STRING',
                    'SCE_HP_STRING',
                    'SCE_HBA_STRING',
                    'SCE_HPA_STRING',
                    'SCE_HPHP_HSTRING',
                    'SCE_HPHP_SIMPLESTRING',
                    'SCE_HP_CHARACTER',
                    'SCE_HP_TRIPLE',
                    'SCE_HP_TRIPLEDOUBLE',
                    'SCE_HPA_CHARACTER',
                    'SCE_HPA_TRIPLE',
                    'SCE_HPA_TRIPLEDOUBLE',
                    ),
        'comments': ('SCE_H_COMMENT',
                     'SCE_H_XCCOMMENT',
                     'SCE_H_SGML_COMMENT',
                     'SCE_HJ_COMMENT',
                     'SCE_HJ_COMMENTLINE',
                     'SCE_HJ_COMMENTDOC',
                     'SCE_HJA_COMMENT',
                     'SCE_HJA_COMMENTLINE',
                     'SCE_HJA_COMMENTDOC',
                     'SCE_HB_COMMENTLINE',
                     'SCE_HBA_COMMENTLINE',
                     'SCE_HP_COMMENTLINE',
                     'SCE_HPA_COMMENTLINE',
                     'SCE_HPHP_COMMENT',
                     'SCE_HPHP_COMMENTLINE',
                     ),
        'keywords': ('SCE_HJ_WORD',
                     'SCE_HJ_KEYWORD',
                     'SCE_HJA_WORD',
                     'SCE_HJA_KEYWORD',
                     'SCE_HBA_WORD',
                     'SCE_HB_WORD',
                     'SCE_HPA_WORD',
                     'SCE_HP_WORD',
                     'SCE_HPHP_WORD',
                    ),
        'stringeol': ('SCE_HJ_STRINGEOL',
                      'SCE_HJA_STRINGEOL',
                      'SCE_HB_STRINGEOL',
                      'SCE_HBA_STRINGEOL',
                      ),
        'classes': ('SCE_HP_CLASSNAME',
                    'SCE_HPA_CLASSNAME'
                    ),
        'functions': ('SCE_HP_DEFNAME',
                      'SCE_HPA_DEFNAME',
                      'SCE_HPHP_DEFAULT',
                      ),
        'operators': ('SCE_HPA_OPERATOR',
                      'SCE_HP_OPERATOR',
                      'SCE_HPHP_OPERATOR',
                      ),
        'start': ('SCE_HBA_START',
                  'SCE_HB_START',
                  'SCE_HP_START',
                  'SCE_HPA_START',
                  'SCE_HJ_START',
                  'SCE_HJA_START',
                  ),
        'variables': ('SCE_HPHP_VARIABLE',
                      'SCE_HPHP_HSTRING_VARIABLE',),
        'regex': ('SCE_HJ_REGEX',
                  'SCE_HJA_REGEX',
                  ),
        'symbols': ('SCE_HJ_SYMBOLS',
                    'SCE_HJA_SYMBOLS',),
        'tags': ('SCE_H_TAG', 'SCE_H_TAGEND',
                 'SCE_H_XMLSTART', 'SCE_H_XMLEND',),
        'unknown tags': ('SCE_H_TAGUNKNOWN',),
        'attributes': ('SCE_H_ATTRIBUTE',),
        'unknown attributes': ('SCE_H_ATTRIBUTEUNKNOWN',),
        'other': ('SCE_H_OTHER',
                  'SCE_H_ENTITY',
                  'SCE_H_SCRIPT',
                  'SCE_H_ASP',
                  'SCE_H_ASPAT',
                  'SCE_H_CDATA',
                  'SCE_H_QUESTION',
                  'SCE_H_VALUE',
                  'SCE_H_SGML_COMMAND',
                  'SCE_H_SGML_1ST_PARAM',
                  'SCE_H_SGML_ERROR',
                  'SCE_H_SGML_SPECIAL',
                  'SCE_H_SGML_ENTITY',
                  'SCE_H_SGML_1ST_PARAM_COMMENT',
                  'SCE_H_SGML_BLOCK_DEFAULT',
                  ),
    },
    'VisualBasic': {
        'default': ('SCE_B_DEFAULT',),
        'comments': ('SCE_B_COMMENT',),
        'numbers': ('SCE_B_NUMBER',),
        'keywords': ('SCE_B_KEYWORD',),
        'strings': ('SCE_B_STRING',),
        'preprocessor': ('SCE_B_PREPROCESSOR',),
        'operators': ('SCE_B_OPERATOR',),
        'identifiers': ('SCE_B_IDENTIFIER',),
        # specific to VB
        'dates': ('SCE_B_DATE',),
        },
    'LaTex': {
        'default': ('SCE_L_DEFAULT',),
        'comments': ('SCE_L_COMMENT',),

        'commands': ('SCE_L_COMMAND',),
        'tags': ('SCE_L_TAG',),
        'math': ('SCE_L_MATH',),
    },
    'Lua': {
        'default': ('SCE_LUA_DEFAULT',),
        'comments': ('SCE_LUA_COMMENT',
                     'SCE_LUA_COMMENTLINE',
                     'SCE_LUA_COMMENTDOC',),
        'numbers': ('SCE_LUA_NUMBER',),
        'strings': ('SCE_LUA_STRING',
                    'SCE_LUA_CHARACTER',
                    'SCE_LUA_LITERALSTRING',
                    ),
        'preprocessor': ('SCE_LUA_PREPROCESSOR',),
        'operators': ('SCE_LUA_OPERATOR',),
        'identifiers': ('SCE_LUA_IDENTIFIER',),
        'stringeol': ('SCE_LUA_STRINGEOL',),
        'keywords': ('SCE_LUA_WORD',),
        'keywords2': ('SCE_LUA_WORD2',
                      'SCE_LUA_WORD3',
                      'SCE_LUA_WORD4',
                      'SCE_LUA_WORD5',
                      'SCE_LUA_WORD6',),
    },
    'Tcl': {
        'default': ('SCE_TCL_DEFAULT',),
        'comments': ('SCE_TCL_COMMENT',),
        'variables': ('SCE_TCL_VARIABLE',),
        'arrays': ('SCE_TCL_ARRAY',),
        'numbers': ('SCE_TCL_NUMBER',),
        'keywords': ('SCE_TCL_WORD',),
        'strings': ('SCE_TCL_STRING',
                    'SCE_TCL_CHARACTER',
                    'SCE_TCL_LITERAL',),
        'identifiers': ('SCE_TCL_IDENTIFIER',),
        'operators': ('SCE_TCL_OPERATOR',),
        'stringeol': ('SCE_TCL_EOL',),
    },
    'Text': {},
    'Perl': {
        'default':('SCE_PL_DEFAULT',
                   'SCE_PL_UNKNOWN_FIELD',
                   'SCE_PL_SUB_ARGS',),
        'errors': ('SCE_PL_ERROR',),
        'comments': ('SCE_PL_COMMENTLINE',
                     'SCE_PL_POD'),
        'numbers': ('SCE_PL_NUMBER',),
        'keywords': ('SCE_PL_WORD',),
        'strings': ('SCE_PL_STRING',
                    'SCE_PL_CHARACTER',
                    'SCE_PL_STRING_Q',
                    'SCE_PL_STRING_QQ',
                    'SCE_PL_STRING_QX',
                    'SCE_PL_STRING_QR',
                    'SCE_PL_STRING_QW',
                    'SCE_PL_LONGQUOTE',
                    ),
        'identifiers': ('SCE_PL_IDENTIFIER',),
        'operators': ('SCE_PL_OPERATOR',
                      'SCE_PL_BACKTICKS',
                      'SCE_PL_VARIABLE_INDEXER'),
        'functions': ('SCE_PL_SUB',),
        'here documents': ('SCE_PL_HERE_DELIM',
                           'SCE_PL_HERE_Q',
                           'SCE_PL_HERE_QQ',
                           'SCE_PL_HERE_QX'),
        'arrays': ('SCE_PL_ARRAY',),
        'hashes': ('SCE_PL_HASH',),
        'symbol tables': ('SCE_PL_SYMBOLTABLE',),
        'regex': ('SCE_PL_REGEX',
                  'SCE_PL_REGSUBST',),
        'preprocessor': ('SCE_PL_PREPROCESSOR',),
        'variables': ('SCE_PL_SCALAR',),
        'data sections': ('SCE_PL_DATASECTION',),
    },
    'Properties': {
        'default': ('SCE_PROPS_DEFAULT',),
        'comments': ('SCE_PROPS_COMMENT',),
        'sections': ('SCE_PROPS_SECTION',),
        'assignments': ('SCE_PROPS_ASSIGNMENT',),
        'defvals': ('SCE_PROPS_DEFVAL',),
    },
    'Batch': {
        'default': ('SCE_BAT_DEFAULT',),
        'comments': ('SCE_BAT_COMMENT',),
        'keywords': ('SCE_BAT_WORD',),
        'functions': ('SCE_BAT_LABEL',),
        'hide': ('SCE_BAT_HIDE',),
        'commands': ('SCE_BAT_COMMAND',),
        'identifiers': ('SCE_BAT_IDENTIFIER',),
        'operators': ('SCE_BAT_OPERATOR',),
    },
    'CSS': {
        'default': ('SCE_CSS_DEFAULT',),
        'tags': ('SCE_CSS_TAG',),
        'classes': ('SCE_CSS_CLASS', 'SCE_CSS_PSEUDOCLASS', 'SCE_CSS_UNKNOWN_PSEUDOCLASS',),
        'operators': ('SCE_CSS_OPERATOR',),
        'identifiers': ('SCE_CSS_IDENTIFIER', 'SCE_CSS_UNKNOWN_IDENTIFIER',),
        'values': ('SCE_CSS_VALUE',),
        'comments': ('SCE_CSS_COMMENT',),
        'ids': ('SCE_CSS_ID',),
        'important': ('SCE_CSS_IMPORTANT',),
        'directives': ('SCE_CSS_DIRECTIVE',),
        'strings': ('SCE_CSS_DOUBLESTRING', 'SCE_CSS_SINGLESTRING',),
    },
    'XML': {
        'default': ( 'SCE_XML_DEFAULT',
                     'SCE_XML_START_TAG_ATTR_EQUALS',
                     'SCE_XML_BOM'),
        'comments': ('SCE_XML_COMMENT_OPEN',
                     'SCE_XML_COMMENT_CONTENT',
                     'SCE_XML_COMMENT_CLOSE',
                    ),
        'prolog': ('SCE_XML_PROLOG',),
        'tags': ('SCE_XML_START_TAG_OPEN',
                 'SCE_XML_START_TAG_NAME',
                 'SCE_XML_START_TAG_CLOSE',
                 'SCE_XML_START_TAG_EMPTY_CLOSE',
                 'SCE_XML_END_TAG_OPEN',
                 'SCE_XML_END_TAG_NAME',
                 'SCE_XML_END_TAG_CLOSE',
                 ),
        'attribute value': ('SCE_XML_START_TAG_ATTR_QUOT_OPEN',
                            'SCE_XML_START_TAG_ATTR_QUOT_CONTENT',
                            'SCE_XML_START_TAG_ATTR_QUOT_CLOSE',
                            'SCE_XML_START_TAG_ATTR_APOS_OPEN',
                            'SCE_XML_START_TAG_ATTR_APOS_CONTENT',
                            'SCE_XML_START_TAG_ATTR_APOS_CLOSE',),
        'attribute name': ('SCE_XML_START_TAG_ATTR_NAME',
                           'SCE_XML_START_TAG_ATTR_NUMBER',
                           'SCE_XML_START_TAG_WHITE_SPACE',
                           'SCE_XML_START_TAG_ATTR_UNQUOTED',
                           'SCE_XML_END_TAG_WHITE_SPACE'),
        'entity references': ('SCE_XML_ENTITY_REF',
                              'SCE_XML_CHAR_REF',),
        'data': ('SCE_XML_DATA_NEWLINE',
                 'SCE_XML_DATA_CHARS'),
        'cdata tags': ('SCE_XML_CDATA_SECT_OPEN', 'SCE_XML_CDATA_SECT_CLOSE'),
        'cdata content': ('SCE_XML_CDATA_SECT_CONTENT', ),
        'pi tags': ('SCE_XML_PI_OPEN', 'SCE_XML_PI_CLOSE'),
        'pi content': ('SCE_XML_PI_CONTENT',),

        'declarations': ('SCE_XML_XML_DECL_OPEN',
                         'SCE_XML_XML_DECL_CONTENT',
                         'SCE_XML_XML_DECL_CLOSE',
                         'SCE_XML_DECLARATION_OPEN',
                         'SCE_XML_DECLARATION_TYPE',
                         'SCE_XML_DECLN_WHITE_SPACE',
                         'SCE_XML_DECLN_NAME',
                         'SCE_XML_DECLN_CLOSE',
                         'SCE_XML_DECLN_QUOT_CONTENT',
                         'SCE_XML_DECLN_APOS_CONTENT',
                         'SCE_XML_DECLN_DATA_CHARS',
                         ),
        'xpath tags': ('SCE_XPATH_TAG_NAME', 'SCE_XPATH_OPEN', 'SCE_XPATH_CLOSE',),
        'xpath attributes': ('SCE_XPATH_ATTR_NAME',),
        'xpath content': ('SCE_XPATH_CONTENT_QUOT', 'SCE_XPATH_CONTENT_APOS',),
    },
    'XSLT': {},
    'Pascal': {},
    'Lua': {},
    'Makefile': {
        'default': ('SCE_MAKE_DEFAULT',),
        'comments': ('SCE_MAKE_COMMENT',),
        'preprocessor': ('SCE_MAKE_PREPROCESSOR',),
        'identifiers': ('SCE_MAKE_IDENTIFIER',),
        'operators': ('SCE_MAKE_OPERATOR',),
        'targets': ('SCE_MAKE_TARGET',),
        'stringeol': ('SCE_MAKE_IDEOL',),
        },
    'Diff': {
        'default': ('SCE_DIFF_DEFAULT',),
        'comments': ('SCE_DIFF_COMMENT',),
        'commands': ('SCE_DIFF_COMMAND',),
        'chunkheader': ('SCE_DIFF_HEADER',),
        'diffline': ('SCE_DIFF_POSITION',),
        'deletionline': ('SCE_DIFF_DELETED',),
        'additionline': ('SCE_DIFF_ADDED',),
    },
    'LaTeX': {},
    'Lisp': {},
    'Ada': {
        'default': ('SCE_ADA_DEFAULT',),
        'keywords': ('SCE_ADA_WORD',),
        'identifiers': ('SCE_ADA_IDENTIFIER',),
        'comments': ('SCE_ADA_COMMENTLINE',),
        'numbers': ('SCE_ADA_NUMBER',),
        'strings': ('SCE_ADA_CHARACTER',
                    'SCE_ADA_STRING',),
        'stringeol': ('SCE_ADA_CHARACTEREOL',
                      'SCE_ADA_STRINGEOL',),
        'illegals': ('SCE_ADA_ILLEGAL',),
        'delimiters': ('SCE_ADA_DELIMITER',),
        'labels': ('SCE_ADA_LABEL',),
        },
    'Apache': {
        'directives': ('SCE_CONF_DIRECTIVE',),
        'parameters': ('SCE_CONF_PARAMETER',),
        'extensions': ('SCE_CONF_EXTENSION',),
        'default': ('SCE_CONF_DEFAULT',),
        'numbers': ('SCE_CONF_NUMBER',),
        'identifiers': ('SCE_CONF_IDENTIFIER',),
        'strings': ('SCE_CONF_STRING',),
        'comments': ('SCE_CONF_COMMENT',),
        'ip_addresses': ('SCE_CONF_IP',),
        },
    'Fortran 77': {},
    'SQL': {},
    'Eiffel': {},
    'Baan': {},
    'nnCrontab': {},
    'Matlab': {},
    'Bullant': {},
    'Errors': {
        'Default': ('SCE_ERR_DEFAULT',),
        'Error lines':
            ('SCE_ERR_CMD',
             'SCE_ERR_PYTHON',
             'SCE_ERR_GCC',
             'SCE_ERR_MS',
             'SCE_ERR_CTAG',
             'SCE_ERR_ELF',
             'SCE_ERR_NET',
             'SCE_ERR_PERL',
             'SCE_ERR_LUA',
             'SCE_ERR_BORLAND',
             'SCE_ERR_IFC',
             'SCE_ERR_PHP')
    },
}

#Derivatives (Shared lexers)
StateMap['XSLT'] = StateMap['XML'].copy()
StateMap['JavaScript'] = StateMap['C++'].copy()
StateMap['Java'] = StateMap['C++'].copy()
StateMap['C#'] = StateMap['C++'].copy()
StateMap['IDL'] = StateMap['C++'].copy()
StateMap['Pascal'] = StateMap['C++'].copy()
StateMap['ASP'] = StateMap['HTML'].copy()
StateMap['PHP'] = StateMap['HTML'].copy()
StateMap['VBScript'] = StateMap['VisualBasic'].copy()
StateMap['Ruby'] = StateMap['Python'].copy()
StateMap['Fortran'] = StateMap['Fortran 77'].copy()

SharedStates = {
    'bracebad' : ('STYLE_BRACEBAD',),
    'bracehighlight' : ('STYLE_BRACELIGHT',),
    'control characters' : ('STYLE_CONTROLCHAR',),
    'linenumbers': ('STYLE_LINENUMBER',),
    'indent guides': ('STYLE_INDENTGUIDE',),
}

for language in StateMap.keys():
    StateMap[language].update(SharedStates)

#ErrorList=SCLEX_ERRORLIST SCE_ERR_
#SCE_ERR_DEFAULT=0
#SCE_ERR_PYTHON=1
#SCE_ERR_GCC=2
#SCE_ERR_MS=3
#SCE_ERR_CMD=4
#SCE_ERR_BORLAND=5
#SCE_ERR_PERL=6
#SCE_ERR_NET=7
#SCE_ERR_LUA=8
#SCE_ERR_CTAG=9
#SCE_ERR_PHP=14
#SCE_ERR_ELF=15
#SCE_ERR_IFC=16
#SCE_ERR_DIFF_CHANGED=10
#SCE_ERR_DIFF_ADDITION=11
#SCE_ERR_DIFF_DELETION=12
#SCE_ERR_DIFF_MESSAGE=13

#xical states for SCLEX_BATCH
#Batch=SCLEX_BATCH SCE_BAT_
#xical states for SCLEX_MAKEFILE
#MakeFile=SCLEX_MAKEFILE SCE_MAKE_

#xical states for SCLEX_DIFF
#Diff=SCLEX_DIFF SCE_DIFF_
#SCE_DIFF_DEFAULT=0
#SCE_DIFF_COMMENT=1
#SCE_DIFF_COMMAND=2
#SCE_DIFF_HEADER=3
#SCE_DIFF_POSITION=4
#SCE_DIFF_DELETED=5
#SCE_DIFF_ADDED=6
#xical states for SCLEX_CONF (Apache Configuration Files Lexer)
#Conf=SCLEX_CONF SCE_CONF_
#SCE_CONF_DEFAULT=0
#SCE_CONF_COMMENT=1
#SCE_CONF_NUMBER=2
#SCE_CONF_IDENTIFIER=3
#SCE_CONF_EXTENSION=4
#SCE_CONF_PARAMETER=5
#SCE_CONF_STRING=6
#SCE_CONF_OPERATOR=7
#SCE_CONF_IP=8
#SCE_CONF_DIRECTIVE=9
#xical states for SCLEX_AVE, Avenue
#Avenue=SCLEX_AVE SCE_AVE_
#SCE_AVE_DEFAULT=0
#SCE_AVE_COMMENT=1
#SCE_AVE_NUMBER=2
#SCE_AVE_WORD=3
#SCE_AVE_STRING=6
#SCE_AVE_ENUM=7
#SCE_AVE_STRINGEOL=8
#SCE_AVE_IDENTIFIER=9
#SCE_AVE_OPERATOR=10
#SCE_AVE_WORD1=11
#SCE_AVE_WORD2=12
#SCE_AVE_WORD3=13
#SCE_AVE_WORD4=14
#SCE_AVE_WORD5=15
#SCE_AVE_WORD6=16
#xical states for SCLEX_BAAN
#Baan=SCLEX_BAAN SCE_BAAN_
#SCE_BAAN_DEFAULT=0
#SCE_BAAN_COMMENT=1
#SCE_BAAN_COMMENTDOC=2
#SCE_BAAN_NUMBER=3
#SCE_BAAN_WORD=4
#SCE_BAAN_STRING=5
#SCE_BAAN_PREPROCESSOR=6
#SCE_BAAN_OPERATOR=7
#SCE_BAAN_IDENTIFIER=8
#SCE_BAAN_STRINGEOL=9
#SCE_BAAN_WORD2=10
#xical states for SCLEX_LISP
#Lisp=SCLEX_LISP SCE_LISP_
#SCE_LISP_DEFAULT=0
#SCE_LISP_COMMENT=1
#SCE_LISP_NUMBER=2
#SCE_LISP_KEYWORD=3
#SCE_LISP_STRING=6
#SCE_LISP_STRINGEOL=8
#SCE_LISP_IDENTIFIER=9
#SCE_LISP_OPERATOR=10
#xical states for SCLEX_EIFFEL and SCLEX_EIFFELKW
#Eiffel=SCLEX_EIFFEL SCE_EIFFEL_
#EiffelKW=SCLEX_EIFFELKW SCE_EIFFEL_
#SCE_EIFFEL_DEFAULT=0
#SCE_EIFFEL_COMMENTLINE=1
#SCE_EIFFEL_NUMBER=2
#SCE_EIFFEL_WORD=3
#SCE_EIFFEL_STRING=4
#SCE_EIFFEL_CHARACTER=5
#SCE_EIFFEL_OPERATOR=6
#SCE_EIFFEL_IDENTIFIER=7
#SCE_EIFFEL_STRINGEOL=8
#xical states for SCLEX_NNCRONTAB (nnCron crontab Lexer)
#NNCronTab=SCLEX_NNCRONTAB SCE_NNCRONTAB_
#SCE_NNCRONTAB_DEFAULT=0
#SCE_NNCRONTAB_COMMENT=1
#SCE_NNCRONTAB_TASK=2
#SCE_NNCRONTAB_SECTION=3
#SCE_NNCRONTAB_KEYWORD=4
#SCE_NNCRONTAB_MODIFIER=5
#SCE_NNCRONTAB_ASTERISK=6
#SCE_NNCRONTAB_NUMBER=7
#SCE_NNCRONTAB_STRING=8
#SCE_NNCRONTAB_ENVIRONMENT=9
#SCE_NNCRONTAB_IDENTIFIER=10
#xical states for SCLEX_MATLAB
#MatLab=SCLEX_MATLAB SCE_MATLAB_
#SCE_MATLAB_DEFAULT=0
#SCE_MATLAB_COMMENT=1
#SCE_MATLAB_COMMAND=2
#SCE_MATLAB_NUMBER=3
#SCE_MATLAB_KEYWORD=4
#SCE_MATLAB_STRING=5
#SCE_MATLAB_OPERATOR=6
#SCE_MATLAB_IDENTIFIER=7
#xical states for SCLEX_SCRIPTOL
#Sol=SCLEX_SCRIPTOL SCE_SCRIPTOL_
#SCE_SCRIPTOL_DEFAULT=0
#SCE_SCRIPTOL_COMMENT=1
#SCE_SCRIPTOL_COMMENTLINE=2
#SCE_SCRIPTOL_COMMENTDOC=3
#SCE_SCRIPTOL_NUMBER=4
#SCE_SCRIPTOL_WORD=5
#SCE_SCRIPTOL_STRING=6
#SCE_SCRIPTOL_CHARACTER=7
#SCE_SCRIPTOL_UUID=8
#SCE_SCRIPTOL_PREPROCESSOR=9
#SCE_SCRIPTOL_OPERATOR=10
#SCE_SCRIPTOL_IDENTIFIER=11
#SCE_SCRIPTOL_STRINGEOL=12
#SCE_SCRIPTOL_VERBATIM=13
#SCE_SCRIPTOL_REGEX=14
#SCE_SCRIPTOL_COMMENTLINEDOC=15
#SCE_SCRIPTOL_WORD2=16
#SCE_SCRIPTOL_COMMENTDOCKEYWORD=17
#SCE_SCRIPTOL_COMMENTDOCKEYWORDERROR=18
#SCE_SCRIPTOL_COMMENTBASIC=19
#xical states for SCLEX_ASM
#Asm=SCLEX_ASM SCE_ASM_
#SCE_ASM_DEFAULT=0
#SCE_ASM_COMMENT=1
#SCE_ASM_NUMBER=2
#SCE_ASM_STRING=3
#SCE_ASM_OPERATOR=4
#SCE_ASM_IDENTIFIER=5
#SCE_ASM_CPUINSTRUCTION=6
#SCE_ASM_MATHINSTRUCTION=7
#SCE_ASM_REGISTER=8
#SCE_ASM_DIRECTIVE=9
#SCE_ASM_DIRECTIVEOPERAND=10
#xical states for SCLEX_FORTRAN
#Fortran=SCLEX_FORTRAN SCE_F_
#F77=SCLEX_F77 SCE_F_
#SCE_F_DEFAULT=0
#SCE_F_COMMENT=1
#SCE_F_NUMBER=2
#SCE_F_STRING1=3
#SCE_F_STRING2=4
#SCE_F_STRINGEOL=5
#SCE_F_OPERATOR=6
#SCE_F_IDENTIFIER=7
#SCE_F_WORD=8
#SCE_F_WORD2=9
#SCE_F_WORD3=10
#SCE_F_PREPROCESSOR=11
#SCE_F_OPERATOR2=12
#SCE_F_LABEL=13
#SCE_F_CONTINUATION=14
#xical states for SCLEX_CSS
#CSS=SCLEX_CSS SCE_CSS_

#xical states for SCLEX_POV
#POV=SCLEX_POV SCE_POV_
#SCE_POV_DEFAULT=0
#SCE_POV_COMMENT=1
#SCE_POV_COMMENTLINE=2
#SCE_POV_COMMENTDOC=3
#SCE_POV_NUMBER=4
#SCE_POV_WORD=5
#SCE_POV_STRING=6
#SCE_POV_OPERATOR=7
#SCE_POV_IDENTIFIER=8
#SCE_POV_BRACE=9
#SCE_POV_WORD2=10
#xical states for the SCLEX_XML (XML files)
