import xmlrpclib

server = xmlrpclib.Server("http://www.oreillynet.com/meerkat/xml-rpc/server.php")

# Get a list of article categories from the O'Reilly Network
categories = server.meerkat.getCategories() 
interestingCategories = []

for category in categories:
    # Add the categories that are related to Python to our
    # interestingCategories list
    if category['title'].lower().find('python') != -1:
        interestingCategories.append(category)    

# Display the articles in HTML
print "<HTML><HEAD><TITLE>Articles</TITLE></HEAD><BODY><H1>Articles</H1>"

# Go through the interesting categories and get all of the
# articles in each category that are less than an hour old.

for category in interestingCategories:
    # Put a heading for the current category
    print "<H2>%s</H2>" % category['title']
    params = {
            'category' : category['id'],    # Search only in this category
            'time_period' : '48HOUR',        # Must be 1 hour old or less
        }
    
    articles = server.meerkat.getItems(params)
    for article in articles:
        # Print out the name of the article in a hyperlink, so clicking on it
        # will take us to the article
        print '<A HREF="%s">%s</A><BR>' % (article['link'], article['title'])

print "</BODY></HTML>"